import java.util.concurrent.locks.*;

public class Deadlock {

  static final Lock l1 = new ReentrantLock ();
  static final Lock l2 = new ReentrantLock ();
  static int count = 0;

  static final int N = 100;

  // In this demo, we spawn two threads, each of which increments the
  // shared counter N times. The first thread repeatedly locks l1 then l2,
  // while the second thread repeatedly locks l2 then l1. It does not take
  // many iterations to obtain a deadlock!

  public static void main (String[] args) throws InterruptedException
  {
    // Print the first command line argument, which serves as the test name or number.
    System.out.print(args[0] + ": ");
    Thread t1 = new Thread (new Runnable () {
      public void run () {
	for (int i = 0; i < N; i++) {
	  l1.lock(); l2.lock();
	  count++;
	  l2.unlock(); l1.unlock();
	}
      }
      });
    Thread t2 = new Thread (new Runnable () {
      public void run () {
	for (int i = 0; i < N; i++) {
	  l2.lock(); l1.lock();
	  count++;
	  l1.unlock(); l2.unlock();
	}
      }
    });
    t1.start(); t2.start();
    t1.join();  t2.join();
    System.out.println("No deadlock! The final count is " + count + ".");
  }

}
