public class DoneSignal {

  // QUIZ. This code will...
  // A. print "yes" B. print "no" C. print neither

  private static int x = 0;
  private static volatile boolean done = false;

  public static void main (String[] args)
  {
    // Print the first command line argument, which serves as the test name or number.
    System.out.print(args[0] + ": ");
    Thread threadA = new Thread (new Runnable () {
      public void run () {
	// Wait.
	for (int i = 0; i < 500000; i++) ;
	// Set x.
	x = 42;
	// Send a signal.
	done = true;
      }
    });
    Thread threadB = new Thread (new Runnable () {
      public void run () {
	// Wait for the signal.
	while (!done) ;
	// Read x.
	int copy = x;
	// Check that x is 42.
	System.out.println(copy == 42 ? "yes, x is 42" : ("no, x is " + copy));
      }
    });
    // Run the two threads and wait for them to terminate (this is implicit).
    threadA.start();
    threadB.start();
  }

  // In this demo, thread A uses the shared variable "done" to
  // send a signal to thread B. Thread A sets x to 42 before
  // sending the signal, and thread B checks that x is 42 when
  // it receives the signal. This code has a race condition on
  // "done", so it can be considered incorrect. And indeed, on
  // my dual-core MacBook Air, it behaves strangely: it sometimes
  // locks up. I suppose that this can be attributed to the JIT
  // compiler starting up and optimizing the loop "while (!done)"
  // into "while (true)". Declaring "done" as volatile fixes the
  // problem.

}