class UnsafeCounterDemo {

  // How many threads are launched.
  final static int THREADS = 2;
  // How many times each thread increments the counter.
  final static int STEPS = 1000000;

  // The shared counter.
  static UnsafeCounter c = new UnsafeCounter ();

  // QUIZ: the final value of the counter will be:
  // A. < 1000000 B. = 1000000 C. > 1000000

  public static void main (String[] args) throws InterruptedException
  {
    // Print the first command line argument,
    // which serves as the test name or number.
    System.out.print(args[0] + ": ");
    // Create and start the threads.
    Thread[] thread = new Thread [THREADS];
    for (int i = 0; i < THREADS; i++) {
      thread[i] = new Thread (new Runnable () {
	public void run () {
	  // Each thread repeatedly increments the counter.
	  for (int i = 0; i < STEPS; i++)
	    c.increment();
	}
      });
      thread[i].start();
    }
    // Wait for the threads to terminate.
    for (int i = 0; i < THREADS; i++)
      thread[i].join();
    // Print the result.
    System.out.println(
      "The final value of the counter is " + c.get() + "."
    );
  }

}
